;Replacement 8080A cpu board for ALTAIR/IMSAI
;Monitor program for 8080A based computer.
;Written by Josh Bensadon
;Free for public use, following the common shareware policies.
;
;CONSOLE BIOS is near end of file, can be modified to talk to any UART
;FLOPPY DISK BIOS is also near end of file
;
;This is the boot loader.  It will copy the ROM program into high RAM and kill the Shadow ROM
;
;This program needs to be 48 bytes long, the System ROM will then be concatenated with this file.
;
;The Target ROM should look like this:
;
;0000  Boot Loader
;...
;002F  Boot Loader
;0030  System ROM   -> gets copied to High RAM at DB00
;...
;xxxx  System ROM
;


CPU_IO		.EQU 20H	;Base address for onboard CPU I/O
PORT2		.EQU CPU_IO+18H

		.CSEG

		.ORG 0H
		JMP	COPY_DO
KILL_0		MVI	A,1		;Turn off ROM Shadow
		OUT	PORT2
KILL_JMP	JMP	CODE_START
COPY_DO		LXI	H,COPY_FROM	;Read from ROM
		LXI	D,CODE_START	;Save at CODE_START
COPY_LP		MOV	A,M
		STAX	D		;Write to RAM
		INX	H
		INX	D
		MOV	A,D
		ORA	E
		JNZ	COPY_LP
		MVI	A,0C3H		;Set Jump @0000
		STA	0
		STA	KILL_JMP
		LXI	H,CODE_START
		SHLD	1		;Replace first Jump destination
		SHLD	KILL_JMP+1
		JMP	KILL_0

		NOP
		NOP
		NOP


COPY_FROM
		.ORG 0DB00H

CODE_START

		.end
